VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   ClientHeight    =   6420
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   8040
   FillColor       =   &H0000FF00&
   ForeColor       =   &H00FFFFFF&
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   428
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   536
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Label Lab 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "0"
      ForeColor       =   &H80000008&
      Height          =   435
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   435
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Vector
  x As Long
  y As Long
End Type

Dim Ar() As Vector
Dim Cnt As Long

Private Sub Form_Load()
Dim n As Long
  Move 0, 0, 1024 * Screen.TwipsPerPixelX, 768 * Screen.TwipsPerPixelY
  For n = 0 To 16
    If n > 0 Then Load Lab(n)
    Lab(n).Move n * 32 + 32, 32
    Lab(n).Caption = n
    Lab(n).Visible = True
  Next n
  Create 192, 480, 9
End Sub

Private Sub Lab_Click(Index As Integer)
Dim n As Long, i As Long
  i = 2 ^ (16 - Index)
  Cls
  For n = 0 To Cnt - i Step i
    Line (Ar(n).x, Ar(n).y)-(Ar(n + i).x, Ar(n + i).y)
  Next n
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Unload Me
End Sub

Private Sub Create(ByVal x As Long, ByVal y As Long, ByVal e As Long)
Dim Sz As Long, s As Long, n As Long, f As Boolean
  Sz = 2 ^ e
  Cnt = Sz * Sz
  ReDim Ar(Cnt)
  Ar(0) = Vector(x, y)
  Ar(Cnt) = Vector(x + Sz, y)
  Ar(Cnt \ 2) = Vector(x + Sz \ 2, y - Sz \ 2)
  
  s = Cnt \ 4
  Do
    For n = s To Cnt Step s * 2
      Ar(n) = Half(Ar(n - s), Ar(n + s), f)
      f = Not f
    Next n
    If s = 1 Then Exit Do
    s = s \ 2
  Loop
End Sub

Private Function Half(v1 As Vector, v2 As Vector, ByVal dLeft As Boolean) As Vector
Dim d As Long
  If v1.y = v2.y Then
    d = (v2.x - v1.x) \ 2
    If dLeft Then Half = Vector(v1.x + d, v1.y - d) Else Half = Vector(v1.x + d, v1.y + d)
  ElseIf v1.x = v2.x Then
    d = (v2.y - v1.y) \ 2
    If dLeft Then Half = Vector(v1.x + d, v1.y + d) Else Half = Vector(v1.x - d, v1.y + d)
  ElseIf (v1.y < v2.y) Xor (v1.x < v2.x) Xor dLeft Then
    Half = Vector(v2.x, v1.y)
  Else
    Half = Vector(v1.x, v2.y)
  End If
End Function

Private Function Vector(ByVal x As Long, ByVal y As Long) As Vector
  Vector.x = x
  Vector.y = y
End Function
